library UnitDistanceHistory requires UnitCoordinateHistory
	//! runtextmacro UnitHistory("Distance")
		private integer Key
		private real lastDistance
		
		method get takes nothing returns real
			return LoadReal(.hash(), Key, whichStep)
		endmethod
		
		private method save takes nothing returns boolean
			local real tx = GetUnitX(whichUnit) - whichUnit:XHistory.step(1).get()
			local real ty = GetUnitY(whichUnit) - whichUnit:YHistory.step(1).get()
			set lastDistance = lastDistance + SquareRoot(tx*tx + ty*ty)
			call SaveReal(.hash(), Key, currentStep, lastDistance)
			return true
		endmethod
		private method onTrim takes nothing returns nothing
			set lastDistance = this.get()
		endmethod
		private method clear takes nothing returns nothing
			call FlushChildHashtable(.hash(), Key)
		endmethod
		
		private static method filter takes unit u returns boolean
			return IsUnitType(u, UNIT_TYPE_STRUCTURE) == false
		endmethod
		private method init takes nothing returns nothing
			set Key = .newKey()
			set lastDistance = 0
		endmethod
	//! runtextmacro endUnitHistory()
endlibrary
