library UnitMoveOrderHistory requires UnitHistory
	//! runtextmacro UnitHistory("MoveOrder")
		private integer Key
		private integer Key2
		private integer Key3
		private integer Key4
		private integer Key5
		private integer lastOrderType
		private integer lastOrderId
		private widget lastOrderTargetWidget
		private real lastOrderTargetX
		private real lastOrderTargetY
		
		private method save takes nothing returns boolean
			if GetUnitCurrentOrder(whichUnit) == 0 and lastOrderId != 851993/*Hold Position*/ then
				set lastOrderType = 2
				set lastOrderId = 851972 //Stop
				set lastOrderTargetWidget = null
				set lastOrderTargetX = 0
				set lastOrderTargetY = 0
			endif
			call SaveInteger(.hash(), Key, currentStep, lastOrderType)
			call SaveInteger(.hash(), Key2, currentStep, lastOrderId)
			call SaveWidgetHandle(.hash(), Key3, currentStep, lastOrderTargetWidget)
			call SaveReal(.hash(), Key4, currentStep, lastOrderTargetX)
			call SaveReal(.hash(), Key5, currentStep, lastOrderTargetY)
			return true
		endmethod
		private method revert takes nothing returns nothing
			local integer orderType = LoadInteger(.hash(), Key, whichStep)
			if orderType == 0 then
				call IssueTargetOrderById(whichUnit, LoadInteger(.hash(), Key2, whichStep), LoadWidgetHandle(.hash(), Key3, whichStep))
			elseif orderType == 1 then
				call IssuePointOrderById(whichUnit, LoadInteger(.hash(), Key2, whichStep), LoadReal(.hash(), Key4, whichStep), LoadReal(.hash(), Key5, whichStep))
			else
				call IssueImmediateOrderById(whichUnit, LoadInteger(.hash(), Key2, whichStep))
			endif
		endmethod
		private method clear takes nothing returns nothing
			call FlushChildHashtable(.hash(), Key)
			call FlushChildHashtable(.hash(), Key2)
			call FlushChildHashtable(.hash(), Key3)
			call FlushChildHashtable(.hash(), Key4)
			call FlushChildHashtable(.hash(), Key5)
		endmethod
		private static method filter takes unit u returns boolean
			return IsUnitType(u, UNIT_TYPE_STRUCTURE) == false
		endmethod
		
		private static method whichOrders takes integer orderId returns boolean
			return orderId == 851972 /*Stop*/ or orderId == 851971/*Smart*/ or orderId == 851986/*Move*/ or orderId == 851983/*Attack*/ or orderId == 851984/*Attack Ground*/ or orderId == 851990/*Patrol*/ or orderId == 851993/*Hold Position*/
		endmethod
		
		private static method recordTargetOrder takes nothing returns boolean
			local thistype this
			if whichOrders(GetIssuedOrderId()) then
				set this = GetTriggerUnit():thistype
				set lastOrderType = 0
				set lastOrderId = GetIssuedOrderId()
				set lastOrderTargetWidget = GetOrderTarget()
				set lastOrderTargetX = 0
				set lastOrderTargetY = 0
			endif
			return false
		endmethod
		private static method recordPointOrder takes nothing returns boolean
			local thistype this
			if whichOrders(GetIssuedOrderId()) then
				set this = GetTriggerUnit():thistype
				set lastOrderType = 1
				set lastOrderId = GetIssuedOrderId()
				set lastOrderTargetWidget = null
				set lastOrderTargetX = GetOrderPointX()
				set lastOrderTargetY = GetOrderPointY()
			endif
			return false
		endmethod
		private static method recordImmediateOrder takes nothing returns boolean
			local thistype this
			if whichOrders(GetIssuedOrderId()) then
				set this = GetTriggerUnit():thistype
				set lastOrderType = 2
				set lastOrderId = GetIssuedOrderId()
				set lastOrderTargetWidget = null
				set lastOrderTargetX = 0
				set lastOrderTargetY = 0
			endif
			return false
		endmethod
		
		private method init takes nothing returns nothing
			local trigger t
			set Key = .newKey()
			set Key2 = .newKey()
			set Key3 = .newKey()
			set Key4 = .newKey()
			set Key5 = .newKey()
			set lastOrderId = 0
			set lastOrderType = 0
			set lastOrderTargetWidget = null
			set lastOrderTargetX = 0
			set lastOrderTargetY = 0
			set t = CreateTrigger()
			call TriggerRegisterAnyUnitEventBJ(t, EVENT_PLAYER_UNIT_ISSUED_TARGET_ORDER)
			call TriggerAddCondition(t, Condition(function thistype.recordTargetOrder))
			set t = CreateTrigger()
			call TriggerRegisterAnyUnitEventBJ(t, EVENT_PLAYER_UNIT_ISSUED_POINT_ORDER)
			call TriggerAddCondition(t, Condition(function thistype.recordPointOrder))
			set t = CreateTrigger()
			call TriggerRegisterAnyUnitEventBJ(t, EVENT_PLAYER_UNIT_ISSUED_ORDER)
			call TriggerAddCondition(t, Condition(function thistype.recordImmediateOrder))
			set t = null
		endmethod
	//! runtextmacro endUnitHistory()
endlibrary
